/* >15tmain.c  */
/*-----------------------------------
16 april 2014: prior for sig changed to R&G version

15 April 2014: prior for mean of normal, extreme and nextreme components
               changed from uniform to normal


14 April 2014: This version has tauconst and sampleBeta commented out
               Also the passing of priorpar parameters and calculation
               of normalising constants has been modified

24 Jul 2012: Added spreaddata output
29 Dec 2012: Changed to receive datafilename as an argument
             Has Init.d as input and produces Out9.d as output


1 May   2012: edm.bat

 GRAPHICSON 0/1 switches graphics off and on in tmain.c tgraph.c

            no graphics in tdist.c  tsubs.c


 compilable with gcc or Watcom

 mkm.bat  makes o object file with gcc
 lkm.bat  makes  tmain.exe  with g77
                   (requires tmain.0 tdist.o tsubs.o tgraph.o

 mkall.bat makes tmain.obj tsubs.obj tdist.obj tgraph.obj with wcl386

 lkall.bat links above to make tmain.exe                  with wcl386




8 Aug 2005: Dataspread is a percentage

1 Oct 2004 Does all models using mean and SD as the parameters p1 and p2.

Handles mixtures by EM/nelmead, so every third parameter is a weight
Note nelmead returns neg of function it minimizes, i.e.
 the lik or logposterior, so largest is best.

This version unlike previous versions has the distribution dependent
subroutines split off as tdist.c

This version only does single fits.
However made easy to add new models.

Run through option MODEL and add it in. 
   tsubs needs altering in just one position
   tgraph need not be altered
if density/cdf used for likelihood calculation.

search on 'GRAPHICSON' for commented out graphics-calls
-------------------------------------*/

#include <math.h>

#include <conio.h>
#include <dos.h>
#include <time.h> /* needed for CLOCKS_PER_SEC */


#include "threep9.h"

#define GRAPHICSON 0

#if GRAPHICSON
   #include <graph.h>
   #include "gengraph.h"
#endif

#define MAXNUMEVALS 2000 // was 1500 number of NelMead iterations before restart
#define NUMNMRESTTS 15 // was 10 number of NelMead restarts

#define SDEXPAND 20  //factor used for capping candidate variances
#define SDCAP 0.5 // SD size at which candidate distn of wts is capped
// OR  ||

#define MAXNUMCOMPS 13 // allows for 12 components

#define TWO 2

// OR  ||

double accuNELMEAD; // set later


long testflag;
long cgedflag;

long hitail;
long model;
long componentmodel;
long outflag; /* indicates if output is printed */
long spacingsflag;   /* for choice of function to be maximised */
long show;
long numevals;
long cdfavail;
double leftendvalue;
double gamlog, gamlog1, gamlog2;
long numcomps;
long maxnumlevs;
long effort;
double * yobs;
double ymindiff;
long n;
long akey, bkey;

char * filedatptr;
FILE * fp7;

// ============= simple subroutines not calling other subroutines ==========

/*===== Calculate inverse matrix (Gaussian elimination, I am afraid!) =====*/
void calcinverse(nn,a,inverse_a)
long nn;
double a[][PSIZE];
double inverse_a[][PSIZE];

{/*0*/

extern double mag(double);
extern void detzero(void);

static long i,j,k,u;

static double pivot;

static double w,ff;

static double tempa[MAXNUMCOMPS][MAXNUMCOMPS]; /*-- work matrix --*/

for(i=1;i<=nn;i++)
   {
   for(j=1;j<=nn;j++)
    {
    tempa[i][j]= a[i][j];
    }
   }

for(i=1;i<=nn;i++)
   {
   for(j=1;j<=nn;j++)
      {
      if(i==j) inverse_a[i][j] = 1.0;
      else inverse_a[i][j] = 0.0;
      }
   }

/*=== Gaussian elimination ===*/
for(i=1;i<=nn-1;i++)
  {/*i*/

  w= 0.0;
  for(j=i;j<=nn;j++)
      {
      if( mag(tempa[j][i])>=w )
        {
        u=j;
        w = mag(tempa[j][i]);
        }
      }

  if(mag(w)<1e-10) {detzero(); return;}

  if(u==i) goto lab600;

  for(k=i;k<=nn;k++)
      {
      ff = tempa[u][k];
      tempa[u][k] = tempa[i][k];
      tempa[i][k] = ff;
      }

  for(k=1;k<=nn;k++)
      {
      ff = inverse_a[u][k];
      inverse_a[u][k] = inverse_a[i][k];
      inverse_a[i][k] = ff;
      }

lab600:
  for(j=i+1;j<=nn;j++)
     {
     pivot = tempa[j][i]/tempa[i][i];
     for(k=1;k<=nn;k++)
       {
       tempa[j][k] = tempa[j][k] - pivot*tempa[i][k];
       inverse_a[j][k] = inverse_a[j][k] - pivot*inverse_a[i][k];
       }
     }

  if (mag(tempa[nn][nn]) < 1e-10 ) { detzero(); return;}

  }/*i*/

/*=== inverse ===*/
for(i=nn;i>=1;i--)
   {
   for(k=1;k<=nn;k++)
     {
     if(i!=nn)
       {
       for(j=i+1;j<=nn;j++)
          {
          inverse_a[i][k] = inverse_a[i][k]-tempa[i][j]*inverse_a[j][k];
          }
       }
     inverse_a[i][k] = inverse_a[i][k]/tempa[i][i];
     }
   }

#if 0
/* ==== diagnostic output === */
printf("\n");
printf("original\n");
for(i=1;i<=nn;i++)
   {
   for(j=1;j<=nn;j++)
    {
    printf(" %8.3lf ",a[i][j]);
    }
   printf("\n");
   }

printf("\n");
printf("inverse\n");
for(i=1;i<=nn;i++)
   {
   for(j=1;j<=nn;j++)
    {
    printf(" %8.3lf ",inverse_a[i][j]);
    }
   printf("\n");
   }

printf("\n Check if original.inverse is the identity matrix\n");
for(i=1;i<=nn;i++)
 {
 for(j=1;j<=nn;j++)
  {
  ff = 0.0;
  for(k=1;k<=nn;k++)
     ff += a[i][k] * inverse_a[k][j];
  printf(" %8.3lf ",ff);
  }
 printf("\n");
 }
#endif

}/*0*/  


/*===========*/


double mag(x)
 double x;

 {
 if(x<0.0) return -x;
 else return x;
 }


void detzero(void)
 {
 printf(" determinant is at or near to zero \n");
 }

/* ==================== determinant ==================== */
double Determinant( long dimension, double matrix[][PSIZE])
{
   static long i, j, k;
   static double Det;
   static double tempFactor;
   static double newMatrix[PSIZE][PSIZE];

   for(i = 1; i<= dimension; i++)
   {
       for(j = 1; j <= dimension; j++)
       {
           newMatrix[i][j] = matrix[i ][j];
       }
   }

   for(k = 1; k < dimension; k++)
   {
       for(i = k + 1; i<= dimension; i++)
       {
           if ( newMatrix[k][ k] == 0) tempFactor = 1;
           else tempFactor = -newMatrix[i][ k] / newMatrix[k][k];
        
           for(j = k + 1; j <= dimension; j++)
           {
              newMatrix[i][ j] = newMatrix[i][ j] + tempFactor * newMatrix[k][ j];
           }
       }
   }

   Det = 1.0;
   for( i = 1; i<= dimension; i++)
   {
       Det = Det * newMatrix[i][ i];
   }

   return Det;

}


/*====== order data ====*/

void sortintoascend( long n, double* a, double* b, double* c )

{/*0*/

double dummy;
int i,j;

for (i=1;i<n;i++)
{/*3*/
   for (j=n-1;j>=i;j--)
   {/*4*/
      if (a[j]>a[j+1])
      {/*5*/

         dummy = a[j];
         a[j] = a[j+1];
         a[j+1] = dummy;

         dummy = b[j];
         b[j] = b[j+1];
         b[j+1] = dummy;

         dummy = c[j];
         c[j] = c[j+1];
         c[j+1] = dummy;

      }/*5*/
   }/*4*/
}/*3*/

}/*0*/



// ======================= main subroutine calls =======================


#if 1
/*==================== Nelder-Mead Simplex Algm ==================*/
/* this is the version where last prob is treated as function of others */
/*--- the bits at $$$$$ stop the setting of negative param values ---*/

double nelmeadmix( yobsn, n, par, parbase, positive, numpar, priorpar)

double * yobsn; 
long n;
double * par;
double * parbase;
long * positive;
long numpar;
double * priorpar;

{/*0*/
  extern long model; /* for choice of model             */
  extern long spacingsflag;   /* for choice of function to be maximised */
  extern long show;
  extern long numevals;
  extern double accuNELMEAD;

double neglogposterior(double *, double *);      /* function to be minimized */


static double al;
static double be;
static double minSD;

static double fc,fe,fg,fh,fl,fo,fr;

static double ga;
static long g;

static long h;

static long i;

static long j;

static long l;

static long p;

static double rfac;

static double s[PSIZE+2][PSIZE+1];
static double sig, s1;
static double steplen[PSIZE];

static double x[PSIZE+1], xh[PSIZE+1], xg[PSIZE+1], xl[PSIZE+1], xo[PSIZE+1];
static double xr[PSIZE+1], xc[PSIZE+1], xe[PSIZE+1], f[PSIZE+2];

static double wtsum;
static double w0;

/*--------------
 Nelmead normally searches par[i] for all i from nxplct+1 to numpar, thus
 p = numpar - nxplct.  If however igiven is one of these then par[igiven]
 is not searched; in this case p = numpar-nxplct-1. If p = 0, no search is
 needed and the likval value is evaluated immediately.

 --------------*/

show = 0;
numevals = 0;
cgedflag = 0;
minSD = priorpar[2];

p= numpar-1;

if(p==0)
{
   fl = neglogposterior(parbase, priorpar);
   par[0] = -fl;
   return -fl;
}

for(j=1;j<=p;j++) /* --- set up point[1] = parbase --- */ 
{
   s[1][j]=parbase[ j ];
   steplen[j] = 0.01*fabs( parbase[ j ] ) /* WAS 0.01 */;
}

/*---SET UP FIRST SIMPLEX AROUND INIT POINT---*/
for(i=2; i<=p+1; i++) /* -- set up the other p points  */
{
   for(j=1; j<=p;   j++) /* -- each component -- */ 
   {
      if(j==i-1) s[i][j] = s[1][j] + steplen[j];
      else       s[i][j] = s[1][j];
      /*$$$$$*/
      if(positive[j]==1) {  if(s[i][j]<0.0) s[i][j] = .0000000001; }
      if(positive[j]==3) {  if(s[i][j]<minSD) s[i][j] = minSD; }
   }

   /* -- check those components that are weights -- */
   if( (i-1)%3==0 ) //--- i runs from 2 to 3k (numpar), so 
   {
      wtsum = 0.0;
      for(j=3; j<=p; j+=3)
      {
         wtsum += s[i][j];
      }
      /* if sum too large must be due to the steplength being too large
         for this component so reduce the offset used for this polong */
      if (wtsum > 1.0) s[i][i-1] = 1.0 - wtsum - s[i][i-1];
   }
}

/*-- ALPHA,BETA,GAMMA --*/
al = 1.0; /*-- reflection  parameter --*/
be = 0.5; /*-- contraction parameter --*/
ga = 2.0; /*-- expansion   parameter --*/

if(show==1)
{
   for(i=1;i<=p;i++)
   {
      x[i] = s[1][i]; par[i] = x[i];
      printf(" x[%d] = %lf ",i,x[i]);
   }
   wtsum = 0.0;
   for(j=3;j<=p;j+=3) wtsum += par[j];
   par[p+1] = 1 - wtsum;
   printf("init fn val = %lf \n",  neglogposterior(par, priorpar) );
}

/*---FIND FN VALS ---*/
for(i=1; i<=p+1; i++)
{
   for(j=1; j<=p; j++)
   {
      x[j] = s[i][j]; par[j] = x[j];
   }
   wtsum = 0.0;
   for(j=3;j<=p;j+=3) wtsum += par[j];
   par[p+1] = 1 - wtsum;

   f[i] = neglogposterior(par, priorpar);

   if(show==1) printf("i,h = %d %lf\n",i,f[i]);
}

/*---FIND---*/
lab8390:
fh = -1e20;
fl =  1e20;

for(i=1;i<=p+1;i++)
{
   if ( f[i] > fh ) { fh = f[i]; h = i;}
   if ( f[i] < fl ) { fl = f[i]; l = i;}
}

/*--  printf("h = %d l = %d\n",h,l); --*/

fg = -1e20;
for(i=1;i<=p+1;i++)
{
   if(i!=h)
   {
      if(f[i] > fg ) { fg = f[i]; g = i;}
   }
}

for(j=1; j<=p; j++)
{
   xo[j] = 0;
   for(i=1;i<=p+1;i++)
   {
      if(i!=h)
         xo[j] += s[i][j];
   }
   /*--- identify  ---*/
   xo[j] = xo[j]/p;
   xh[j] = s[h][j];
   xg[j] = s[g][j];
   xl[j] = s[l][j];
}  

for(j=1;j<=p;j++)
{
   par[j] = xo[j];
}
wtsum = 0.0;
for(j=3;j<=p;j+=3) wtsum += xo[j];
par[p+1] = 1. - wtsum;
fo =  neglogposterior(par, priorpar);
if(show==1) printf("centroid fo = %lf\n",fo);


/*--- REFLECTION ---*/
for(j=1;j<=p;j++)
{
   xr[j] = xo[j] + al * ( xo[j] - xh[j] );
   /*$$$$$*/
   if(positive[j]==1) {if(xr[j]<0.0) xr[j] = .0000000001;}
   if(positive[j]==2) {if(xr[j]<0.0) xr[j] = .0000000001;}
   if(positive[j]==3) {  if(xr[j]<minSD) xr[j] = minSD; }
   x[j]  = xr[j];
   par[j] = x[j];
}  
wtsum = 0.0;
for(j=3;j<=p;j+=3) wtsum+=x[j];
if(wtsum > 1.0)
{
   w0 = 0.0;
   for(j=3;j<=p;j+=3) w0+= xo[j];
   rfac = (1.0-w0)/(wtsum-w0);
   for(j=3;j<=p;j+=3)
   {
      xr[j] = xo[j] + rfac * al * (xo[j]-xh[j]);
      x[j] = xr[j];
      par[j] = x[j];
   }
   par[p+1] = 0.0;
}
else
   par[p+1] = 1.0 - wtsum;

fr =  neglogposterior(par, priorpar);
if(show==1) printf("REFLECTION fr = %lf\n",fr);


/*--- IF FR<FL  then EXPANSION  ---*/
if(fr < fl) goto lab8780;

/*--- IF FR>FL AND ... ---*/
if(fr > fg) goto lab8930;
else goto lab8890;

/*--- EXPANSION ---*/
lab8780:
for(j=1;j<=p;j++)
{
   xe[j] = xo[j] + ga * (xr[j] - xo[j]);
   /*$$$$$*/
   if(positive[j]==1) {if(xe[j]<0.0) xe[j] = 0.0000000001;}
   if(positive[j]==2) {if(xe[j]<0.0) xe[j] = 0.0000000001;}
   if(positive[j]==3) {  if(xe[j]<minSD) xe[j] = minSD; }
   x[j]  = xe[j];
   par[j] = x[j];
}
wtsum = 0.0;
for(j=3;j<=p;j+=3) wtsum+=x[j]; // --- add up the weights
if(wtsum > 1.0)                 // --- if sum > 1.0
{
   w0 = 0.0;
   for(j=3;j<=p;j+=3) w0+= xo[j];
   rfac = (1.0-w0)/(wtsum-w0);
   for(j=3;j<=p;j+=3)
   {
      xe[j] = xo[j] + rfac * ga * (xr[j]-xo[j]);
      x[j] = xe[j];
      par[j] = x[j];
   }
   par[p+1] = 0.0;
}
else
   par[p+1] = 1.0 - wtsum;

fe =  neglogposterior(par, priorpar);
if(fe >= fl) goto lab8890;

for(j=1; j<=p; j++)
{
   s[h][j] = xe[j];
}

f[h] = fe;
if(show==1) printf("EXPANSION fe = %lf\n",fe);
goto lab9170;

/*--- REFLECTION ---*/
lab8890:
for(j=1; j<=p; j++)
{
   s[h][j] = xr[j];
}

f[h] = fr;
if(show==1) printf("REFLECTION fr = %lf\n",fr);
goto lab9170;

lab8930:
if(fr > fh) goto lab8990;
for(j=1;j<=p;j++)
{
   xh[j] = xr[j];
}

f[h] = fr;

/*--- CONTRACTION ---*/
lab8990:
for(j=1;j<=p;j++)
{
   xc[j] = be * xh[j] + (1.0 - be) * xo[j];
   if(positive[j]==1) {if(xc[j]<0.0) xc[j] = 0.0000000001;}
   if(positive[j]==2) {if(xc[j]<0.0) xc[j] = 0.0000000001;}
   if(positive[j]==3) {  if(xc[j]<minSD) xc[j] = minSD; }

   x[j]  = xc[j];
   par[j] = x[j];
}

wtsum = 0.0;
for(j=3;j<=p;j+=3)
{
   wtsum+=x[j];
}
/* For contraction rescaling should not be nec */
par[p+1] = 1.0-wtsum;

fc =  neglogposterior(par, priorpar);
if(fc > fh) goto lab9100;

for(j=1; j<=p; j++)
{
   s[h][j] = xc[j];
}

f[h] = fc;
if( show == 1)  printf("CONTRACTION  fc = %lf\n",fc);
goto lab9170;

lab9100:
for(i=1;i<=p+1;i++)
{
   for(j=1;j<=p;j++)
   {
      s[i][j] = (s[i][j] + xl[j] )/2.0;
      /*$$$$$*/
      if(positive[j]==1) {if(s[i][j]<0.0) s[i][j] = 0.0000000001;}
      if(positive[j]==2) {if(s[i][j]<0.0) s[i][j] = 0.0000000001;}
      if(positive[j]==3) {if(s[i][j]<minSD) s[i][j] = minSD; }
      
      x[j] = s[i][j];
      par[j] = x[j];
   }
   wtsum = 0.0;
   for(j=3;j<=p;j+=3){ wtsum+=x[j]; }
   par[p+1] = 1.0 - wtsum;

   f[i] =  neglogposterior(par, priorpar);
}

if(show==1) printf("REDUCTION \n");


/*--- TEST SIMPLEX ---*/
lab9170:
s1 = 0;
for(i=1;i<=p+1;i++)
{
   s1 += f[i];
}
s1 = s1/(p+1);
sig = 0.0;
for(i=1;i<=p+1;i++)
{
   sig += (f[i]-s1) * (f[i]-s1);
}

if(sig >= accuNELMEAD && numevals<MAXNUMEVALS ) goto lab8390;
/*
printf("min obtained \n");
*/
if(sig<accuNELMEAD) cgedflag = 1;
else cgedflag = 0;

for(j=1;j<=p;j++)
{
   par[j] = xl[j];
}

wtsum = 0.0;
for(j=3;j<=p;j+=3)
{
     wtsum+=xl[j];
}
par[p+1] = 1.0-wtsum;

/* ================
for(j=1;j<=p+1;j++)
{
   printf("X(%d)= %lf\n",j,par[j] );
   // printf("no. of evals= %d fn min = %lf \n", tev, f[l] );
}
=================*/

par[0] = -f[l];
return -f[l];

}/*0*/
#endif


/*====== Note this version either calculates the inverse or else the
         information matrix, using infomatrixflag
====== */

void infomatrix(long numpars, double theta[], double infmat[][PSIZE], double priorpar[])

{/*0*/
static long i, j, k;
static double lik00, lik01, lik10, lik11;

static double delstep[PSIZE];
static double th00[PSIZE];
static double th01[PSIZE];
static double th10[PSIZE];
static double th11[PSIZE];
static double infvar[PSIZE][PSIZE];
static double infmat2[PSIZE][PSIZE];

//extern void calcinverse(long nn, 
//           double a[][PSIZE], double inverse_a[][PSIZE]);

extern double neglikval(double param[], double priorpar[] );
extern double neglogposterior(double param[], double priorpar[] );

static double delta;

static long infomatrixflag;
static long numcomps;

infomatrixflag = 1; // set this to 0 to return inverse of infomatrix
                    // i.e. the variance
                    // set this to 1 to return the infomatrix
                    // i.e. the inverse of the Hessian

numcomps = numpars/3;

/* ====== INFOMAT form estimate of variance from information matrix ====== */
   for(i=1;i<=numpars;i++)
   {

      delta = theta[i];
      if(delta<=0.0)
      {
         printf(" Warning!!!!! theta[%ld]=%lf\n",i, theta[i]);
      }

      delstep[i] = 0.0001 * fabs(delta);

      // delstep[i] = 0.0001 * fabs(theta[i]);
      // --- printf("t[%ld]=%lf del=%lf", i, theta[i], delstep[i]);
   }
   // --- printf("\n");
   // --- getch();


   for(i=1;i<=numpars;i++)
   for(j=1;j<=numpars;j++)
   {
      for(k=1;k<=numpars;k++)
      {
         th11[k] = theta[k];
         th10[k] = theta[k];
         th01[k] = theta[k];
         th00[k] = theta[k];
      }

      if(i!=j)
      {         

         th11[i] += delstep[i];
         th11[j] += delstep[j];
         
         th10[i] += delstep[i];
         th10[j] -= delstep[j];

         th01[i] -= delstep[i];
         th01[j] += delstep[j];

         th00[i] -= delstep[i];
         th00[j] -= delstep[j];
 
/*
         lik11 = -neglikval(th11, priorpar);
         lik10 = -neglikval(th10, priorpar);
         lik01 = -neglikval(th01, priorpar);
         lik00 = -neglikval(th00, priorpar);
*/
         lik11 = -neglogposterior(th11, priorpar);
         lik10 = -neglogposterior(th10, priorpar);
         lik01 = -neglogposterior(th01, priorpar);
         lik00 = -neglogposterior(th00, priorpar);

         infmat2[i][j] = -( lik11 - lik10 - lik01 + lik00 )/(4.*delstep[i]*delstep[j]);

      }
      else
      {
         th11[i] += delstep[i];
         th00[i] -= delstep[i];
/*
         lik11 = -neglikval(th11, priorpar);
         lik10 = -neglikval(th10, priorpar);
         lik01 = -neglikval(th01, priorpar);
         lik00 = -neglikval(th00, priorpar);
*/
         lik11 = -neglogposterior(th11, priorpar);
         lik10 = -neglogposterior(th10, priorpar);
         lik01 = -neglogposterior(th01, priorpar);
         lik00 = -neglogposterior(th00, priorpar);

         infmat2[i][j] = -( lik11 - lik10 - lik01 + lik00 )/(delstep[i]*delstep[j]);

      } 

      // printf("l11=%lf l10=%lf l01=%lf l00=%lf\n", lik11,lik10,lik01,lik00);
       
      // printf("infm[%ld][%ld]=%lf \n",i,j,infmat[i][j]);
 
   }/*i&j*/

   for(i=1;i<=numpars;i++)
   for(j=1;j<=numpars;j++)
   {
      infmat[i][j] = infmat2[i][j];
   }/*i&j*/

// The subroutine returns infmat
// if zero, return inverse of infomatrix
   if (infomatrixflag == 0) 
   {
       // This calcs infvar from infmat
       calcinverse(numpars, infmat, infvar); 
       
       for(i=1;i<=numpars;i++)
       {
          for(j=1;j<=numpars;j++)
          {
             infmat[i][j] = infvar[i][j];
          }
       }
   }

}/*0*/


void EigenAnalysis( double a[][PSIZE], double v[][PSIZE], long Dimension)

//  a is the square symmetric matrix
//  v is the matrix of eigenvectors produced
//  tL is the number of sig figs
//  dimension is the number of dimensions

{
static long i, j, k, iH;
static double b[PSIZE][PSIZE];
static double D[PSIZE][PSIZE];
static double aMax;
static double aa;
static double zero;
static double sum;
static double sSum;
static double tol;
static double tL;
static double tT;

static double si;
static double co;

//  Set b equal to a and d to the zero matrix
for(i=1; i<=Dimension; i++)
{
    for(j=1; j<=Dimension; j++)
    {
        b[i][j] = a[i][j];
        D[i][j] = 0.0;
    }
}

//  Initialization
tL = 0.000000001;
zero = 0.0;
sum = zero;
tol = fabs(tL);

//  Set initial eigenvectors
for(i=1; i<=Dimension; i++)
{
    for(j=1; j<=Dimension; j++)
    {
        if(tL > zero) v[i][j] = 0.0;
        sum = sum + fabs(a[i][j]);
    }
    if( tL > zero) v[i][i] = 1.0;
}

// check for trivial
if( Dimension == 1) goto ExitLabel;
if (sum <=0.0) goto ExitLabel;

sum = sum / (Dimension * Dimension);

//  Reduce matrix to diagonal
do
{
   sSum = zero;
   aMax = zero;
   for(j=2; j<=Dimension; j++)
   {
      iH = j - 1;
      for(i=1; i<=iH; i++)
      {
         aa = fabs(a[i][j]);
         if(aa > aMax) aMax = aa;
         sSum = sSum + aa;
         if (aa > 0.1 * aMax)
         {
            //  Calc rotation angle
//            aa = atan2(a[i][i] - a[j][j], 2.0 * a[i][j]) / 2.0;
            aa = atan2( 2.0 * a[i][j], a[i][i] - a[j][j]) / 2.0;
//printf("i=%ld j=%ld a[i][i]=%lf a[j][j]= %lf a[i][j]=%lf atan=%lf\n",
//i,j, a[i][i], a[j][j], a[i][j], aa );
//getch();
            si = sin(aa);
            co = cos(aa);
            for(k=1; k<=Dimension; k++)
            {
               tT = a[k][i];
               a[k][i] = co * tT + si * a[k][j];
               a[k][j] = -si * tT + co * a[k][j];
               tT = v[k][i];
               v[k][i] = co * tT + si * v[k][j];
               v[k][j] = -si * tT + co * v[k][j];
            }
        
            //  modify diagonal terms
            a[i][i] = co * a[i][i] + si * a[j][i];
            
            a[j][j] = -si * a[i][j] + co * a[j][j];
            a[i][j] = zero;
            
            // make A [] symmetrical
            for(k=1; k<=Dimension; k++)
            {
               a[i][k] = a[k][i];
               a[j][k] = a[k][j];
            }
             // A(i,j) made zero by rotation
         }  
      }

   }

} while ( fabs(sSum) / sum > tol);

ExitLabel:
;
     
} //end of EigenAnalysis


void CalculateModifiedHessian(long k, double Hessian[][PSIZE],
double Jacobian[][MAXNUMCOMPS],  double ModHess[][PSIZE]
)

{
long i, j, L, p; 

static double hessAlphaAlpha [PSIZE][PSIZE];
static double hessAlphaW [PSIZE][PSIZE];
static double hessWAlpha [PSIZE][PSIZE];
static double hessWW [PSIZE][PSIZE];
static double modHessAlphaW [PSIZE][PSIZE];
static double modHessWAlpha [PSIZE][PSIZE];
static double modHessWW [PSIZE][PSIZE];

// Separate Hessian into sub-matrices
for(i=1; i<=2*k; i++)
{
    for(j=1; j<=2*k; j++)
    {
        hessAlphaAlpha[i][j] = Hessian[i][j];
    }
    for(j=1; j<=k; j++)
    {
        hessAlphaW[i][j] = Hessian[i][ 2 * k + j];
        hessWAlpha[j][i] = Hessian[2 * k + j][ i];
    }
}


for(i=1; i<=k; i++)
{
    for(j=1; j<=k; j++)
    {
        hessWW[i][j] = Hessian[2 * k + i][ 2 * k + j];
    }
}



// Find modified sub-matrices
for(i=1; i<=2*k; i++)
{
    for(j=1; j<=k; j++)
    {
	modHessAlphaW[i][j] = 0.0;
	modHessWAlpha[j][i] = 0.0;
        for(L=1; L<=k; L++)
        {
            modHessAlphaW[i][j] = modHessAlphaW[i][j]  
                + hessAlphaW[i][L] * Jacobian[j][ L];
            modHessWAlpha[j][i] = modHessWAlpha[j][i]  
                + hessWAlpha[L][i] * Jacobian[j][L];
        }
    }
}
            

for(i=1; i<=k; i++)
{
    for(j=1; j<=k; j++)
    {
        modHessWW[i][j] = 0.0;
        for(p=1; p<=k; p++)
        {
            for(L=1; L<=k; L++)
            {
                modHessWW[i][j] = modHessWW[i][j]  
                    + Jacobian[i][p] * hessWW[p][L]  
                    * Jacobian[j][L];
            }
        }
    }
}


// Combine the modified sub-matrices
    for(i=1; i<=2*k; i++)
    {
        for(j=1; j<=2*k; j++)
        {
            ModHess[i][j] = hessAlphaAlpha[i][j];
        }
        for(j=1; j<=k; j++)
        {
            ModHess[i][ j + 2 * k] = modHessAlphaW[i][j];
            ModHess[j + 2 * k][ i] = modHessWAlpha[j][i];
        }
    }
    for(i=1; i<=k; i++)
    {
        for(j=1; j<=k; j++)
        {
            ModHess[2 * k + i][ 2 * k + j] = modHessWW[i][j];
        }
    }
} // End sub


/* =============  Generalized inverse Calculation ================== */
//  Note : matrix L is returned
//  D is altered by EigenAnalysis and becomes diagonal matrix of eigenvalues

void CalcGeneralisedInverse(
 double D[][PSIZE], double L[][PSIZE], long k, long * NegEVCountptr)

{

// void EigenAnalysis( double a[][PSIZE], double v[][PSIZE], long Dimension);


static double P[PSIZE][PSIZE]; //  Eigen vectors in columns
static double m[PSIZE][PSIZE];

long i, j; 
double dMax;

// In this sub, letters refer to document written by R Cheng
// in Feb 03


// Perform eigen-analysis on D [] converting it to a diag matrix of e-values
// Also get P [], the matrix of e-vectors
 
EigenAnalysis ( D, P, 3 * k);


dMax = 1e-8;


/* -------------- */
#if 0
fprintf(fp7,"Eigen vals k=%ld\n", k);

for(i=1; i<=3*k; i++)
{
    for(j=1; j<=3*k; j++)
    {
        if(fabs(D[i][j]) > dMax)
        {
            fprintf(fp7," %lf",D[i][j]);
        }
        else fprintf(fp7," %lf", 0.0);
    }
    fprintf(fp7,"\n");
}
#endif
/* -------------- */


// Find M
dMax = -1e20;

for(i=1; i<=3*k; i++)
{
    for(j=1; j<=3*k; j++)
    {
        if(D[i][j] > dMax)
        {
            dMax = D[i][j];
        }
        m[i][j] = 0;
    }
}
if( dMax == 0) dMax = 0.000000001;

for(i=1; i<=3*k; i++)
{
    // Allow for rounding error in calc of e-values
    if(fabs(D[i][i] / dMax) < 1e-15)
    {
        D[i][i] = 0;
    }
    // This assumes that if d(i,i) is negative it is actually just positive
    if(D[i][i] < 0)
    {
        printf("! Neg Eval at k=%ld E(%ld)=%e\n",k, i, D[i][i]);
        *NegEVCountptr = (*NegEVCountptr) + 1;
        getch();
        D[i][i] = 0.00000001;
    }
    if(D[i][i] != 0.0)
    {
        m[i][i] = 1.0 / D[i][i];
    }
}
    
// Find L and output
for(i=1; i<=3*k; i++)
{
    for(j=1; j<=3*k; j++)
    {
        L[i][j] = P[i][j] * pow(m[j][j], 0.5);
    }
}

// Find G and output
//for(i=1; i<=3*k; i++)
//{
//    for(j=1; j<=3*k; j++)
//    {
//        g[i][j]  0.0;
//        for(q=1; q<=3*k; q++)
//        {
//            g[i][j] = L[i][q] * L[j][q] + g[i][j];
//        }
//    }
//}

} // End of Calcinverse




int main(int argc, char * argv[])

{/*0*/

#if 1 // 

 extern double neglikval(double *, double *);
 extern double neglogposterior(double *, double *);

 extern void sortintoascend(long, double*, double*, double* );

// extern void CalculateModifiedHessian(long k, double Hessian[][PSIZE],
//              double Jacobian[][MAXNUMCOMPS],  double ModHess[][PSIZE]);

// extern void CalcGeneralisedInverse(
//     double D[][PSIZE], double L[][PSIZE], long k, long * NegEVCountptr);


// void addinterval(long, long, double*, double*, double*, long*, long*, long*, long*);

 double explicitcdf( double, double*);

 void fitstat( double*, long, double*, long, double*, double* );

 void graphplot(double *, long, double *, long, double *, long, long, long, long);

// void Dvalplot(double *, long, double *, long*, double *, long*, long*, double *);

 extern void Dvalplot2(long*, double*, long, double*, double*, double*, long*, long*, long*, long*);

// void infomatrix(long, double *, double *, double *);

// void infomatrix(long numpars, double theta[], double infmat[][PSIZE], double priorpar[]);


// double nelmead(double *, long, double *, double *, long *, long);
// double nelmeadmix(double *, long, double *, double *, long *, long, double *);

 void spread ( double *, double *, long ,double);
 void spread2 ( double *, double *, long, double);

 double leftendfind(long, double*, double, double );

 double gammalog(double, long);
 double bigphi(double);
 double incompgam(double, double, double, long);

// double quanc8(double, double, double * );


FILE * fp9; // ===== This is the main results file output by the fitter exe

static double param[PSIZE];

double priorZeta;

double priorDelta;
double priorKappa;
double priorNu1;
double priorNu2;
double priorGamma2;
long priorKMax;
double priorKsi;
double Groupsize;
double Stretch;

double priorAlpha;
double priorAlphaInit;
double priorGee;
double priorHch;


double NormConstNormal;
double NormConstBeta2;

double NormConstSigRG;

double Dataspread;

long show;


double coeffvar;

static double mu [ MAXNUMCOMPS ];
static double tau[ MAXNUMCOMPS ];
static double awt[ MAXNUMCOMPS ];


 long numcomps0;
// long outnum;
 long numoISsamples;
// double sampleBeta;
 double minSD;
// double tauConst;

 long numpars;



 static long adjustonflag;
 static double adstat;
 static double accupercent;
 static double astar=0.;  /* Anderson-Darling test statistic */
 static double aicstat;   // Akaike Information Criterion
 static double bicstat;

 static double cdf;
 static double critlevel;

 static double delta0, delta1, delta2;

 static long EMflag, EMflag0;

 char filenameres[20];

 FILE * fp1; // input file

 FILE * fout;
 FILE * foutsdata;

//  FILE * fout0; // diagnostic output file not needed in working version
//  FILE * fp5;  // diagnostic output file not needed in working version

 static long akey;

 static long bestjtry;
 static double dummy;
 static double diff;

 static long lessjtry;
 static double lessratio;

 static long kMaxSample;

 static long i;
 static long inel;
 static long invaccuofobsns;

 static long ifault=0;
 static long igiven;
 static long ib, iis;
 static long istt, iend;

 static long jk;
 
 static long j;
 static long j0, j1, j2, j3;
 static long jlo, jhi;
 static long j0old,j1old;
 static long jtry;

 static long k;
 
 static double lam;

 static long leftendflag;

 static long m;
 static double m1, m2;
 static double maxdiff, mindiff;
 static double maxvalue, maxvaluesofar;
 static double maxprobsofar, maxprobsofar0, maxprobsofar1;
 static double mux,sig;

 
 static double newlikelihdval, newspacingsval;
 static long  numcompsprev, numcompspres, numcompsnew;
 static long numtries;
 static long nxplct;

 static double obsmean, obssig;
 static double preslikelihdval, presspacingsval;
 static long onepass;

 static long p;
 static long pauseflag;
 
 static double sampmean,sampsig,sampskew,samprange, sampmidrange;
 static double ssquared;
 static double samplogmean, samplogsig, samphmean;
 static long spacingsflagpres;
 static long spacingsflagnew;
 static double sd0, sd1, sd2, sd3;
 static double ssigma;

 static double t1,t2;

 static double xd, xt;

 static double WeibullAlpha, WeibullCee;
 static double p0, p1;
 static double s0, s1;
 static double x0, x1;

 static double a[MAXNUMCOMPS];
 static double b[MAXNUMCOMPS];
 static double c[MAXNUMCOMPS];

 static double Dval[NSIZE];
 static long positive[PSIZE];
 static double parprev[PSIZE];
 static double parbase[PSIZE];
 static double parpres[PSIZE];
 static double parnew[PSIZE];
 static double partry[PSIZE][TWO];
 static double infvar[PSIZE][PSIZE];
 static double maxval[TWO];
 static double phimas;

 static double segval,segval1;
 static double suml, sumlsq, sumy;

 static double tee;
 static double thetamas;

 static double upper;

 static double ydifflo[NSIZE];
 static double ydiffhi[NSIZE];
 static double yobsn[NSIZE];
 static double yobsno[NSIZE];
 static double ytemp[NSIZE];
 static double ymas[NSIZE];   /* for Anderson-Darling test */
 static double priorpar[PSIZE];

 static double ymin, ymax;

static long it, jt, iquotient, jquotient, iremainder, jremainder;

static double ShrinkFactor;

static double Shessian[PSIZE][PSIZE];
static double ShrunkhessiansAll[PSIZE][PSIZE][TWO][MAXNUMCOMPS];

static double Jacobian[MAXNUMCOMPS][MAXNUMCOMPS];
static double JacobiansAll[MAXNUMCOMPS][MAXNUMCOMPS][MAXNUMCOMPS];

static double ModHessian[PSIZE][PSIZE];
static double ModHessiansAll[PSIZE][PSIZE][TWO][MAXNUMCOMPS];

static double sampleL[PSIZE][PSIZE];
static double sampleLsAll[PSIZE][PSIZE][TWO][MAXNUMCOMPS];

static double invCov[PSIZE][PSIZE];

static double FittedMean[MAXNUMCOMPS][MAXNUMCOMPS];
static double FittedTau[MAXNUMCOMPS][MAXNUMCOMPS];
static double FittedDelta[MAXNUMCOMPS][MAXNUMCOMPS];

static double FittedMeanAll[MAXNUMCOMPS][TWO][MAXNUMCOMPS];
static double FittedTauAll[MAXNUMCOMPS][TWO][MAXNUMCOMPS];
static double FittedDeltaAll[MAXNUMCOMPS][TWO][MAXNUMCOMPS];

static double AICStatAll [TWO][MAXNUMCOMPS];
static double BICStatAll [TWO][MAXNUMCOMPS];


static long bestjtryAll      [MAXNUMCOMPS];
static double maxvalsAll     [TWO][MAXNUMCOMPS];
static double infvarsAll [PSIZE][PSIZE][TWO][MAXNUMCOMPS];

static double x;
static long NegEigenvalueCount;

static char DataFileName[20];
static char DataFolderInit[30];
static char DataFolderOut9[30];
static char DataFolderSpreadData[30];


/*=======  start ======*/
 show = 0;

// printf("argv1=%s\n",argv[1]); //This is the data file name
// getch();

 strcpy(DataFileName, argv[1]);

 strcpy(DataFolderInit,DataFileName);
 strcat(DataFolderInit,"/Init.d");

 strcpy(DataFolderOut9,DataFileName);
 strcat(DataFolderOut9,"/Out9.d");

 strcpy(DataFolderSpreadData,DataFileName);
 strcat(DataFolderSpreadData,"/SpreadData.d");


 printf("datafile name = %s\n",DataFileName);
 printf("Input  file = %s\n",DataFolderInit);
 printf("Output file = %s\n",DataFolderOut9);

 printf("\n");

// printf("\nPress a key to continue");
// getch();


 filedatptr = filenameres;
 yobs = yobsn;

fp1 = fopen(DataFolderInit,"r");

/*== get num-pts ===*/
 fscanf(fp1,"%ld",&n);
 printf("numDataPoints= %d \n",n);

/*== get yobsno[]  ===*/
 for (i=1;i<=n;i++)
   {/*2*/
   fscanf(fp1,"%lf\n",&yobsno[i]);
   if(show==4)
     {
     printf("y = %7.2lf ",yobsno[i]);
     if((i%4)==0)printf("\n");
     }
   }/*2*/
 if(show==4)printf("\n\n");

 // =================== Process the data =================
 // horrid bubblesort
 for (i=1;i<n;i++)
 {/*3*/
    for (j=n-1;j>=i;j--)
    {/*4*/
       if (yobsno[j]>yobsno[j+1])
       {/*5*/
          x = yobsno[j];
          yobsno[j] = yobsno[j+1];
          yobsno[j+1] = x;
       }/*5*/
    }/*4*/
 }/*3*/

 ymin = yobsno[1];
 ymax = yobsno[n];

 // ----- find smallest positive y difference; this is called ymindiff
 ymindiff = 1e20;
 for(i=2; i<=n; i++)
 {
   xt = yobsno[i] - yobsno[i-1];
   if( xt > 0.0 && xt < ymindiff ) ymindiff = xt; 
 }

 sampmean = 0; sampsig = 0;
 sampskew = 0.0;
 ssquared = 0.0;

 for(i=1;i<=n;i++)
 {
   sampmean += yobsno[i];
   ssquared += yobsno[i] * yobsno[i];
 }
 sampmean = sampmean/(double)n;
 ssquared = ssquared/(double)n;

 printf("ssquared = %lf\n",ssquared);

 for(i=1;i<=n;i++)
 {
   sampsig += pow( yobsno[i]-sampmean, 2.0);
 }
 sampsig = sqrt(sampsig/(double)n);

 for(i=1;i<=n;i++)
 {
   sampskew += (yobsno[i]-sampmean) * pow( yobsno[i]-sampmean, 2.0);
 }
 sampskew = sampskew/(double)n;
 sampskew = sampskew/sampsig;

 samprange = yobsno[n] - yobsno[1];

 sampmidrange = 0.5 * (yobsno[1] + yobsno[n]);

 printf("sampmean = %lf sampsig = %lf sampskew = %lf\n",
         sampmean,sampsig,sampskew); 
 printf("yobsn[1]=%lf yobsn[%d]=%lf\n", yobsno[1], n, yobsno[n]);
 printf("samprange = %lf ymindiff=%lf\n\n", samprange, ymindiff);

 fscanf(fp1,"%lf", &Dataspread);
 invaccuofobsns = 500; // At present this is an arbitrarily set accuracy
 
 // ===== count number of replicated obsns in the original sample =====
 j = 0;
 for(i=2; i<=n; i++)
 {
    xt = yobsno[i] - yobsno[i-1];
    if( xt == 0.0 ) j++;
 }
 printf("There are j=%ld replicated observations.\n\n", j );
 
 printf("Remove possible spurious accuracy ? y/n \n");
 printf("[\n");
 printf("  This has two steps:\n");
 printf("  1. The observations are rounded to the accuracy (Sample Range)/(InvAccu)\n");
 printf("     where InvAccu = %ld\n", invaccuofobsns);
 printf("  2. Replicated observations are spread uniformly in an interval of\n");
 printf("     width (Dataspread/100) * Sample Range, where Dataspread=%4.1lf\n",
              Dataspread );
 printf("]\n\n");

 akey = getch();
 if(akey=='y')
 {
    /* ----- Remove spurious accuracy ----- */
    for(i=1; i<=n; i++) // relocate to make all values positive
    {
       yobsn[i] = yobsno[i]-ymin;
    }
    for(i=1; i<=n; i++) // scale to make all values (strictly) less than unity
    {
       yobsn[i] = (0.999999)*yobsn[i]/yobsn[n];
    }

    printf("In Step 1:\n");
    printf(" InvAccu set to %ld\n", invaccuofobsns);
    for(i=1; i<=n; i++) // scale up to given accuracy
    {
       j = (long)invaccuofobsns*yobsn[i];
       yobsn[i] = j;
    }
    
    for(i=1; i<=n; i++) // restore to original range; Note yobsno[.] used !!!!
    {
       yobsno[i] = (ymax-ymin)*yobsn[i]/(double)invaccuofobsns + ymin;
    }
 
    // ======== count number of replicated rounded obsns ========
    j = 0;
    for(i=2; i<=n; i++)
    {
       xt = yobsno[i] - yobsno[i-1];
       if( xt == 0.0 ) j++;
    }
    printf("After Step 1: There are j=%ld replicated observations.\n\n", j );

    // Check maximum allowed spread if order of observed values
    // is not to be disturbed

    // This next segment not explicitly used at present
    // ----- First check on min and max positive differences
    j = 1;
    ytemp[j] = 1.0;
    switch(model)
    {/*switch*/

    case XMIXTURE:
    case NXMIXTURE:
    case NMIXTURE:
       ydifflo[j] = 1e20;
    break;

    case WMIXTURE:
    case GMIXTURE:
    case LMIXTURE:
    case IMIXTURE:
       ydifflo[j] = yobsno[1];
    break;

    }/*switch*/


    for(i=2;i<=n;i++)
    {

       diff = yobsno[i]-yobsno[i-1];
       if(diff==0.0)
       {
          ytemp[j] += 1.0; // counts number of obsns with same value
          ytemp[i] = 0.0; // current i is a replicated value
       }
       else // diff > 0.0, so start a new count
       {
          ydiffhi[j] = diff;
          j = i;
          ytemp[j] = 1.0;
          ydifflo[j] = diff;
       }
    }
    ydiffhi[j] = 1e20;

    // if ytemp[j] = 0.0 then this is a replicated value
    

    /*---- now spread the sample ---*/

    //  delta = samprange/( 20.*(double)n ); // old versions
    //  spread(yobsno, yobsn, n, delta);   // this takes yobsno to yobsn

    // delta1 = Dataspread * samprange/ (double)n; // use delta1 or delta2
    // delta2 = Dataspread * ymindiff;

    // Dataspread is a percentage of the data range ( defined in two ways) 
    delta0 = Dataspread * samprange/ (double)100.0;

    spread2(yobsno, yobsn, n, delta0);


    /* ---- Note data now in yobsn[.] ---- */
    
    // printf("Sort again? y/n \n");
    // akey = getch();
    printf("In Step 2:\n");
    printf(" Sorting again\n");
    akey = 'y';
    if(akey=='y')
    {
       // bubblesort again ================
       for (i=1;i<n;i++)
       {/*3*/
          for (j=n-1;j>=i;j--)
          {/*4*/
             if (yobsn[j]>yobsn[j+1])
             {/*5*/
                x = yobsn[j];
                yobsn[j] = yobsn[j+1];
                yobsn[j+1] = x;
             }/*5*/
          }/*4*/
       }/*3*/

       // ======== count number of replicated observations ========
       j = 0;
       for(i=2; i<=n; i++)
       {
          xt = yobsn[i] - yobsn[i-1];
          if( xt == 0.0 ) j++;
       }
       printf("After Step 2: There are j=%ld replicated observations.\n\n", j );
       if(j>0)
       {
          printf(" Try a slightly different Dataspread value\n\n");
          printf(" Exit? y/n \n");
          akey = getch();
          if(akey=='y') goto ExitLabel;
       }

       // printf("Spacings? y/n \n");
       // printf("Spacings NOT used \n");
       // akey = getch();
       akey = 'n';
       if(akey=='y') spacingsflag = 1;
       else spacingsflag = 0;

    }

 } // end of spreading segment
 else
 {
    for(i=1;i<=n;i++)
    {
       yobsn[i] =yobsno[i];
    }
 }

// ==== output spread data ====
foutsdata = fopen(DataFolderSpreadData,"w");
fprintf(foutsdata, "%ld\n", n);
for(i=1;i<=n;i++)
{
    fprintf(foutsdata, "%lf\n", yobsn[i]);
}
fclose(foutsdata);


//-------------------
// for(i=1;i<=n;i++)
// {
//    printf ("y[%d]=%lf yspd[%d]=%lf\n",i,yobsno[i], i, yobsn[i]);
//    if(i%4==0) getch();
// }
//-------------------

/*-------- no location shift -------*/
 obsmean = sampmean;
 obssig = sampsig;

 obsmean = 0;
 obssig = 1.0;

 /* ================
 for(i=1;i<=n;i++)
 {
    yobsn[i] = (yobsno[i]- obsmean)/obssig;
    if(show==4)
    {
       printf("normalised y[%2d] = %lf ",i,yobsn[i]);
       if(i%4==0) printf("\n");
    }
    yobsn[i] = yobsno[i];
 }
  ================*/

// ============= Read in  model details ==================

 fscanf(fp1,"%ld", &bkey);  // === This is the model ID

 // ========= model bkey values ===========
 switch(bkey)
 {
    case 3: printf("XMIXTURE (Extreme value mixture))\n"); break;
    case 4: printf("NXMIXTURE (Negative extreme value mixture)\n"); break;
    case 5: printf("WMIXTURE (Weibull mixture)\n"); break;
    case 1: printf("NMIXTURE (Normal mixture)\n"); break;
    case 2: printf("LMIXTURE (Lognormal mixture)\n"); break;
    case 6: printf("GMIXTURE (Gamma mixture)\n"); break;
    case 7: printf("IMIXTURE (Inverse Gaussian mixture)\n"); break;
 }

/* ==================================
 Now select the model details
  use:
    leftendflag = -1 for search of lower end point
    leftendflag = 0  if definitely zero,
    leftend = i if parameter i is the endpoint.
===================================== */
 switch(bkey)
 {
    case 3: model = XMIXTURE; componentmodel=EXTREME2; cdfavail = 1; leftendflag = -1; onepass = 0; break;
    case 4: model = NXMIXTURE; componentmodel=NEXTREME2; cdfavail = 1; leftendflag = -1; onepass = 0; break;
    case 5: model = WMIXTURE; componentmodel=WEIBULL2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
    case 1: model = NMIXTURE; componentmodel=NORMAL; cdfavail = 1; leftendflag = -1; onepass = 0; break;
    case 2: model = LMIXTURE; componentmodel=LOGNORM2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
    case 6: model = GMIXTURE; componentmodel=GAMMA2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
    case 7: model = IMIXTURE; componentmodel=INVG2; cdfavail = 1; leftendflag = 0; onepass = 0; break;
 }


 fscanf(fp1,"%ld", &numoISsamples);
 printf("# of IS samples =%ld\n", numoISsamples);

 fscanf(fp1,"%lf", &minSD);  
           

 fscanf(fp1,"%lf", &priorDelta); 
 fscanf(fp1,"%ld", &priorKMax);
 fscanf(fp1,"%lf", &priorNu1);


 fscanf(fp1,"%lf", &Stretch);
 fscanf(fp1,"%lf", &Groupsize);

 fscanf(fp1,"%lf", &priorAlphaInit);
 fscanf(fp1,"%lf", &priorGee);
 fscanf(fp1,"%lf", &priorHch);


 fclose(fp1);

 printf("Maximum number of (prior) components = %ld\n", priorKMax);
 numcomps0 = priorKMax;


 printf("Priorgee = %lf\n",priorGee);


 // ====== Initialize the parameters defining the prior distributions
 // ====== of the model parameters


 // =======================================================

 // === In previous versions of the program, the BETA2 prior distn is used:

 //      (i) for mean par1 of component models when this has to be positive
 //      (ii) for sig par2 of component models as this has to be positive

 // === When used, the params of the BETA2 prior distn, are always denoted
 //        by Nu1 and Nu2

 // === case (i) still applies for the LN, Weibull, Gamma and IG
 //     component modls

 //     so nu1 and nu2 still have to be set up here

 priorNu2 = ( 4.0 * Stretch + 2.0 ) * priorNu1 - 4.0;
 priorNu2 = priorNu2/(Stretch * priorNu1 - 2.0);

 // === these are passed through to tsubs.c together with two other pars
 //     that depend on nu1 and nu2:

 priorGamma2 = ( (priorNu2 - 2.0)/priorNu2 ) * sampsig;
 NormConstBeta2 = gammalog( (priorNu1+priorNu2)/2.0, ifault)
           - gammalog(priorNu1/2.0, ifault) - gammalog(priorNu2/2.0, ifault);

 //     These 4 parameters are used in tsubs for when evaluating the
 //     prior distn of param1 in the LN, Weibull, Gamma and IG models 

 // =======================================================

 priorZeta = samprange;

 // ===== adjust Hch to get R&G's h parameter

 priorHch = priorHch/(samprange * samprange);

 // ==== use priorGee = priorHch * (priorAlpha - 1.0) * (ssquared)
 //      to get alpha

 priorAlpha = 1.0 + priorGee/(priorHch * ssquared);

 printf("\n\npriorAlphaInit = %7.3lf. Alternative value = %7.3lf\n\n",
                                 priorAlphaInit, priorAlpha);
 printf("Use Alternative value? y/n  ");

 akey = getch();

 if(akey=='n')
 {
    priorAlpha = priorAlphaInit;
    printf("\n\nDefault value of priorAlpha = %7.3lf has been used\n",
                                                                priorAlpha );
 }
 else
 {
    printf("\n\nCalculated value of priorAlpha = %7.3lf has been used\n",
                                                                priorAlpha );
 }

 printf("Press key to continue\n");
 getch();

 NormConstSigRG = log(2.0) + gammalog(priorAlpha+priorGee, ifault)
                  - gammalog(priorAlpha, ifault) - gammalog(priorGee, ifault)
                  + priorGee * log(priorHch);
                   

 // ====== priorNormConst3 is calculated directly in tsubs
 

 switch(model)
 {
   case NMIXTURE:
   case XMIXTURE:
   case NXMIXTURE:
    /* ====== Pars of the prior distn for the first param (param1) === */

    priorKsi = sampmidrange;

    NormConstNormal = -( 0.5 * log(2.0 * 3.141593) + log(priorZeta) );   


    break;

   case LMIXTURE:
   case GMIXTURE:
   case WMIXTURE:
   case IMIXTURE:
    // case p1 is mean p2 is SD

    if(sampmean<0.0) {printf("sampmean is neg!!\n"); getch();}

    // ==== the prior for param1 in these component models is the same as
    // ---- for param2 except that a different gamma scaling is used

    priorKappa = ( (priorNu2 - 2.0)/priorNu2 ) * sampmean;

    priorGamma2 = ( (priorNu2 - 2.0)/priorNu2 ) * sampsig;

    break;

 }



// ======= there are 17 priorpars:


priorpar[1] = priorZeta; // This is the sample range
priorpar[2] = minSD;     // this is only used in nelmeadmix
priorpar[3] = priorKappa; // Inv of the stretched sample variance
                          // or the equivalent of the gamma scaling but for mean
priorpar[4] = priorKsi;   // sampmidrange
priorpar[5] = priorDelta;
priorpar[6] = priorKMax;
priorpar[7] = priorNu1/2.0; // simpler to pass through half-values
priorpar[8] = priorNu2/2.0;
priorpar[9] = priorGamma2;
priorpar[10] = Stretch;
priorpar[11] = Groupsize;
                                                            
priorpar[12] = NormConstNormal;
priorpar[13] = NormConstBeta2;

priorpar[14] = priorAlpha;
priorpar[15] = priorGee;
priorpar[16] = priorHch;

priorpar[17] = NormConstSigRG;



// printf("nu1 = %lf nu2 = %lf\n", priorNu1, priorNu2);

// printf("\nRun with pauses? (Y / B(for best plot option) / N) \n");
 printf("\nRun with pauses? (y/n) \n");
 akey = getch();


 if(akey=='y' || akey=='Y')
    pauseflag = 1;
 else if(akey=='b'|| akey=='B')
    pauseflag = 2;
 else
 {
    pauseflag = 0;
    adjustonflag = 0;
 }

 if(pauseflag == 1)
 {
    printf(" Results not recorded.\n");
    akey = 'n';
 }
 else
    akey = 'n';


 // akey == 'n' always here so outflag = 0 always in this version

 if(akey=='y') outflag = 1;
 else outflag = 0;

 // ================ not used ================
 if(outflag == 1)
 {
    printf("Name of output file? Advise %s.res \n", filedatptr);
    scanf("%s",filenameres);
    printf("%s\n",filenameres);
    fout = fopen(filenameres,"w");
    fprintf(fout," Data file is: %s.d \n",filedatptr);
 

    switch(bkey)
    {
    case 3: fprintf(fout,"XMIXTURE\n"); break;
    case 4: fprintf(fout,"NXMIXTURE\n"); break;
    case 5: fprintf(fout,"WMIXTURE\n"); break;
    case 1: fprintf(fout,"NMIXTURE\n"); break;
    case 2: fprintf(fout,"LMIXTURE\n"); break;
    case 6: fprintf(fout,"GMIXTURE\n"); break;
    case 7: fprintf(fout,"IMIXTURE\n"); break;
    }
 }



// printf("\n 0-LOWTAIL, 1-HITAIL, 2-CDF?\n");
// akey = getch();
akey = '2';
 switch(akey)
 {
    case '0': case ')': hitail = 0; break;
    case '1': case '!': hitail = 1; break;
    case '2': case '@': hitail = 2; break;
 }

 if(
    model==WMIXTURE ||
    model==LMIXTURE ||
    model==GMIXTURE ||
    model==IMIXTURE
   )
 {
    for(i=1;i<=n;i++)
    {
       if(yobsn[i]<=0.0)
       {
          yobsn[i]=yobsn[n]/(100.0*n);
          printf("y[%d]<=0.0 resetting to %lf\n",i,yobsn[i]);
       }
    } 
 }

 if( (leftendflag==-1) && (cdfavail==0) )
 {
    printf("\n Standard likelihood used as cdf not available and left limit of the\n");
    printf(" support of the pdf is not known, making quadrature tricky. Press key\n");
    spacingsflag = 0;
    akey = getch();
 }
 else
 {
    if(pauseflag == 1)
    {
//       printf("\n Either the original-lik or spacings\n");
//       printf(" Choose:\n");
//       printf("    0 - original\n    1 - spacings.\n");
//       akey = getch();
         akey = '0';
         printf("Maximizing the likelihood\n");
    }
    else
    {
       akey = '0'; // normal likelihood
    }

    switch(akey)
    {
       case '0': case ')': spacingsflag = 0; break;
       case '1': case '!': spacingsflag = 1; break;
    }
 }
 printf("spacingsflag = %d\n",spacingsflag);

 if(spacingsflag==0)
 {
    if(pauseflag==1)
    {
 //      printf("\n Nelmead (0) or EM (1)\n");
 //      akey = getch();

//  ============ Permanently set to Nelmead =========== 
       akey = '0';
       printf("Using Nelder-Mead optimization\n");
    }
    else
    {
       akey = '0'; // Nelmead
    }
    switch(akey)
    {
       case '0': case ')': EMflag = 0; break;
       case '1': case '!': EMflag = 1; break;
    }
 }
 else EMflag = 0; /*if spacingsflag=1 then spacings, and must use Nelmead */

//  printf("Preset accuracy Y/N\n");
//  akey=getch();
akey = 'Y';
 if(akey=='y'||akey=='Y')
 {
    accuNELMEAD = 1e-18;
 }
 else
 {
    printf(" accuNELMEAD, (eg  1e-16)\n");
    scanf("%lf %lf %lf", &accuNELMEAD);
 }
 printf(" accuNELMEAD= %e\n",
          accuNELMEAD);

// printf("number of components? \n");
printf("number of components= %ld \n", numcomps0);

/* ====
 switch(akey)
 {
    case '1': numcomps0 = 1; break;
    case '2': numcomps0 = 2; break; 
    case '3': numcomps0 = 3; break;
    case '4': numcomps0 = 4; break; 
    case '5': numcomps0 = 5; break;
    case '6': numcomps0 = 6; break; 
    case '7': numcomps0 = 7; break;
    case '8': numcomps0 = 8; break;
    default: numcomps0 = 8; 
 }
 printf("%d\n", numcomps0);
==== */

 /*
    printf("numlevels ? (try 1!)\n");
    scanf("%d",&maxnumlevs);
 */
 maxnumlevs = 1;
/*-----------------------------------------
 Setup initial parameter values for Nelder-Mead and
 output these initial values in original parameterization
------------------------------------------*/
 switch(model)
 {/*switch*/

 case XMIXTURE:
 case NXMIXTURE:
 case NMIXTURE:
    /* -- characterization of parameter type for Nelmead -- */
    for(i=1;i<MAXMIXTURECOMPONENTS;i++)
    {
       positive[3*(i-1)+1] = 0;
       positive[3*(i-1)+2] = 3; /*WAS 1*/       
       positive[3*(i-1)+3] = 2;       
    }
 break;

 case WMIXTURE:
 case GMIXTURE:
 case LMIXTURE:
 case IMIXTURE:
    /* -- characterization of parameter type for Nelmead -- */
    for(i=1;i<MAXMIXTURECOMPONENTS;i++)
    {
       positive[3*(i-1)+1] = 1; /* scale  or mean */
       positive[3*(i-1)+2] = 1; /* shape (power) or sig WAS 3*/
       positive[3*(i-1)+3] = 2;       
    }
    break;

 }/*switch*/

    numcomps = 1; /* note numcomps initially set to 1 as components are built up */
    numpars = 3;
    nxplct = 0;

    for(i=1;i<=1;i++)
    {
       parbase[3*(i-1)+2] = sampsig;
       parbase[3*(i-1)+1] = sampmean;
       parbase[3*(i-1)+3] = 1.0/(double)numcomps; /* weights */  
    }

    for(i=1;i<=numcomps;i++)
    {
       printf("mu[%d]=%lf sig[%d]=%lf wt[%d]=%lf\n",
           i, parbase[3*(i-1)+1], i, parbase[3*(i-1)+2], i, parbase[3*(i-1)+3]);
    }
    printf("n=%d neglikval = %lf\n", n, neglikval(parbase, priorpar) );


/*======  search for the maximum value and point   ========*/


/*====== code in file ONEPASS from here ===== */
if(onepass==0)
{
   effort = 0;


   for(numcomps=1;numcomps<=numcomps0;numcomps++)
   {/*numcomps*/
      numpars = 3*numcomps;

      if(numcomps==1) numtries = 1;
      else numtries = 2;
      
      maxvalue = -1e20;
      for(jtry=0; jtry<numtries; jtry++)
      {//jtry

         printf("\nFitting %ld components; jtry = %ld\n", numcomps, jtry);
         // At 1st pass parbase already set externally, otherwise do this:
         numevals = 0;
         if(numcomps>1)
         {
            if(jtry==0)
            {
               jlo = j0;
               jhi = j1;
               maxprobsofar = maxprobsofar0;
            }
            else
            {
               jlo = j2;
               jhi = j3;
               maxprobsofar = maxprobsofar1;
            }

            for(i=1;i<=numcomps-1;i++) // ----- get previous solution -----
            {
               parbase[3*(i-1)+1]= parprev[3*(i-1)+1];
               parbase[3*(i-1)+2]= parprev[3*(i-1)+2];
               parbase[3*(i-1)+3] = parprev[3*(i-1)+3]*(1.0-maxprobsofar);
            }

            // ----------- Set up new component -----------------
            parbase[3*(numcomps-1)+1]=(yobsn[jhi]+yobsn[jlo] )/2.0;
            parbase[3*(numcomps-1)+2]=(yobsn[jhi]-yobsn[jlo] )/2.0; //WAS4.0
            if(parbase[3*(numcomps-1)+2] == 0.0)
            {
               parbase[3*(numcomps-1)+2]=ymindiff;
            }

            parbase[3*(numcomps-1)+3]=maxprobsofar;    

            numevals = 0;

         }// numcomps>1 setup

         /*----
         printf("Initial trial solution to be optimized numevals =%ld:\n",numevals);
         for(i=1;i<=numpars;i++)
         {
            printf(" parbase[%d]=%lf ",i,parbase[i]);
            if(i%3==0) printf("\n");
         }
         getch();
         ----*/

         if(EMflag==0)
         {
            for(inel=1;inel<=NUMNMRESTTS;inel++)
            {

               maxval[jtry] = nelmeadmix( yobsn, n, param, parbase, positive, numpars, priorpar);
               param[0] = maxval[jtry];
               if (cgedflag==1) break;
               else
               {
                  printf("Not converged at restart = %ld numevals in loop = %ld\n",inel, numevals);
               }
               for(i=1;i<=numpars;i++)
               {
                  parbase[i] = param[i];
               }
            }
	    if(cgedflag==1) printf("Nelder Mead converged at restart = %ld numevals in loop= %ld\n", inel, numevals);
            else printf("Not converged at restart = %ld numevals in loop = %ld\n", inel, numevals);
            
            numevals = 0;
         }
         else
         {
//            EM_Initialisation_And_Call( yobsn, n, param, parbase, numpars);
//            maxval[jtry] = param[0];
              ;
         }


         // =========== order components according to first param. ==========

         for(i=1; i<=numcomps; i++)
         {
            a[i] = param[3*(i-1)+1];
            b[i] = param[3*(i-1)+2];
            c[i] = param[3*(i-1)+3];
         }
         sortintoascend(numcomps, a, b, c);
         for(i=1; i<=numcomps; i++)
         {
            param[3*(i-1)+1] = a[i];
            param[3*(i-1)+2] = b[i];
            param[3*(i-1)+3] = c[i];
         }


         /*----
         for(i=1;i<=numpars;i++)
         {
            printf(" parbase[%d]=%lf ",i,parbase[i]);
            if(i%3==0) printf("\n");
         }
         for(i=1;i<=numpars;i++)
         {
            printf(" param[%d]=%lf ",i,param[i]);
            if(i%3==0) printf("\n");
         }
         printf("Calculating information matrix at numcomps=%ld\n",numcomps);
         ----- */


         /* --- Gather results for current number of components --- */

         // ============= output to fout0 ===================
         for(j=1; j<=numcomps; j++)
         {
            FittedMeanAll [j][jtry][numcomps] = param[3*(j-1)+1];
            FittedTauAll  [j][jtry][numcomps] = param[3*(j-1)+2];
            FittedDeltaAll[j][jtry][numcomps] = param[3*(j-1)+3];
         }

         aicstat = 2.0 * neglikval(param, priorpar) + 2.0 * numpars +
                       2.0 * numpars * (numpars + 1.) / (n - numpars - 1.);

         bicstat = 2.0 * neglikval(param, priorpar) +
                                            numpars * log((double)n);

         AICStatAll [jtry][numcomps] = aicstat;
         BICStatAll [jtry][numcomps] = bicstat;


         maxvalsAll[jtry][numcomps] = maxval[jtry];
         
         if(numcomps==1)
         {
            maxvalsAll[1][numcomps] = -10000.0;
            // printf("numcomps=%ld jtry = %ld maxval[jtry] = %lf\n",
            //    numcomps, jtry, maxval[jtry]);
            // getch();
         }

         // ====== this returns the inverse of the unrestricted Hessian of the logposterior ====
         infomatrix(numpars, param, infvar, priorpar);

         for(i=1;i<=numpars;i++)
         {
            for(j=1;j<=numpars;j++)
            {
               infvarsAll[i][j][jtry][numcomps] = infvar[i][j];
            }
         }
         // ============ end of output to fout0 =============

         // getch();


         if(pauseflag==1)
         {
            printf("numevals used in initial optimn= %d\n",numevals);
            for(i=1;i<=numpars;i++)
            {
               printf("param[%d] = %lf ", i, param[i]);
               if(outflag==1) fprintf(fout,"param[%d] = %lf ", i, param[i]);
               if(i%3==0)
               {
                  printf("\n");
                  if(outflag==1) fprintf(fout,"\n");
               }
            }    
            printf("maxvalue     = %.10lf effort =%d\n",maxval[jtry], effort);
            if(outflag==1)  fprintf(fout,"maxvalue     = %.10lf effort =%d\n",maxvalue, effort);


            // fitstat( &adstat, cdfavail, yobsn, n, param, Dval);
            // printf("AIC/BIC statistic = %lf\n",adstat);

            // printf("AIC statistic = %lf\n",aicstat);
            printf("BIC statistic = %lf\n",bicstat);


            if(outflag==1)
            {
               // fprintf(fout,"AIC/BIC statistic = %lf\n",adstat);

               fprintf(fout,"AIC statistic = %lf\n",aicstat);
               fprintf(fout,"BIC statistic = %lf\n",bicstat);
            }

            printf("End of %ld component fit, jtry = %ld\n", numcomps, jtry);

#if GRAPHICSON
            printf("Graph of solution? (Y/N)\n");
            akey=getch();
#else
            akey = 'n';
#endif

         }
         else
         {
            akey = 'n';
         }

         x0 = leftendfind(leftendflag,param,sampmean,sampsig);
         leftendvalue = x0;

#if GRAPHICSON
         if(akey=='y' || akey=='Y')
            graphplot(yobsn, n, param, 0, Dval, j0, j1, j2, j3);
#endif         

         // ===== store current solution, jtry ======
         for(i=1;i<=numpars;i++)
         {
            partry[i][jtry] = param[i];
         }            

         // ===== check if current solution is an improvement
         if(maxval[jtry] > maxvalue)
         {
            maxvalue = maxval[jtry];
            bestjtry = jtry;
         }

      } //jtry



      // ====== select best fit for the current number of components =====
      /*-----------------------------------------------
      param[3] is (ymin-threshold estimate) or spread parameter,
      param[2] is estimate of original shape par,
      param[1] is estimate of the scale parameter
      All in normalized units

      Now switch over to original units for output and drawing
      ------------------------------------------------*/

      bestjtryAll[numcomps] = bestjtry;

      for(i=1;i<=numpars;i++) /* -- reinstate better set of estimates -- */
      {
         param[i] = partry[i][bestjtry];
      }

      if(pauseflag==1)
      {
         if(numcomps>1)
         {
            for(jtry = 0;jtry<=1;jtry++)
            {
               printf("maxval[%ld]=%lf\n",jtry,maxval[jtry]);
            }
            lessjtry = 1 - bestjtry;
            printf("log difference=%lf mode-ratio=%lf\n",
                    maxval[bestjtry]-maxval[lessjtry],
                    exp(maxval[bestjtry]-maxval[lessjtry]) );
            printf("maxvalue = %lf bestjtry=%ld\n",maxvalue, bestjtry);
            printf("lowvalue = %lf lessjtry=%ld\n",maxval[lessjtry], lessjtry);
            // getch();
         }
         else // ----- first fit
         {
               printf("maxval[%ld]=%lf\n",0,maxval[0]);
         }
      }

      /*------ calculate bestfit par estimates in original units ------*/
      switch(model)
      {
         case XMIXTURE:
         case NXMIXTURE:
         case WMIXTURE:
         case NMIXTURE:
         case LMIXTURE:
         case GMIXTURE:
         case IMIXTURE:
         for(i=1;i<=numcomps;i++)
         {
            parpres[3*(i-1)+1] = param[3*(i-1)+1]*obssig + obsmean;
            parpres[3*(i-1)+2] = param[3*(i-1)+2]*obssig;
            parpres[3*(i-1)+3] = param[3*(i-1)+3];
         }
         break;
      }
      /*===*/
      printf("Best %ld component solution is:\n", numcomps);
      for(j=1;j<numpars;j+=3)
      {
         printf("Component %2ld:  Mean = %lf SD = %lf Weight = %lf\n",
           (j+2)/3, parpres[j], parpres[j+1], parpres[j+2]);
  
      }

      lessjtry = 1 - bestjtry;
      printf(" Top solution is %lf at jtry=%ld\n",maxval[bestjtry],bestjtry);
      if(numtries==2)
      {
         printf(" 2nd solution is %lf at jtry=%ld\n",maxval[lessjtry],lessjtry);
      }

      for(j=1;j<numpars;j+=3)
      {
         if(parpres[j+1]< samprange/1000.)
         {
            coeffvar = parpres[j+1]/parpres[j];
            printf("\n");
            printf("WARNING !!!\n");
            printf(" The SD of component %d is small. \n",(j+2)/3 );
            printf(" It is %6.4lf percent of the sample range.\n",
                             parpres[j+1]*100/samprange);
            printf(" The coefficient of variation of the component is %lf\n\n",
                        coeffvar);
            printf(" Consider:\n");
            printf(" 1. Activating spreading of data or, if spreading\n");
            printf("    is already active, increasing Dataspread.\n\n");
            printf(" 2. Alternatively, increase nu_1.\n\n");
            printf(" (It may be necessary to do both.)\n\n");
            printf(" Exit immediately? y/n\n");
            akey = getch();
            if(akey=='y') goto ExitLabel;
         }
         if(parpres[j+2]< 1./(double)n)
         {
            printf("\n");
            printf("WARNING !!!\n");
            printf(" The weight of component %d is less than 1/n = %lf\n\n", (j+2)/3, 1./n );
            printf(" Consider increasing delta\n\n");
            printf(" Exit immediately? y/n\n");
            akey = getch();
            if(akey=='y') goto ExitLabel;
         }                
      }

      /* --- set left support value --- */
      x0 = leftendfind(leftendflag,parpres,sampmean,sampsig);
      leftendvalue = x0;

      /* --- Calc, using parpres -> the goodness of fit stat, also Dval array  --- */
    
      // fitstat( &adstat, cdfavail, yobsn, n, parpres, Dval);
      // printf("AIC/BIC = %lf\n",adstat);


      aicstat = 2.0 * neglikval(param, priorpar) + 2.0 * numpars +
                     2.0 * numpars * (numpars + 1.) / (n - numpars - 1.);


      bicstat = 2.0 * neglikval(parpres, priorpar) + numpars * log((double)n);

      // printf("AIC statistic = %lf\n",aicstat);
      printf("BIC statistic = %lf\n",bicstat);


#if GRAPHICSON
      if(pauseflag==2)
      {
         printf("Press 'b' for plot of best %ld component fit\n", numcomps);
         akey = getch();
         if(akey=='b' || akey=='B')
         {
            graphplot(yobsn, n, parpres, 0, Dval, j0, j1, j2, j3);
         }
      }
#endif

      printf("End of %ld component fit\n",numcomps);

      if(numcomps<numcomps0)
         printf("\nPress key to begin %ld component fit\n",numcomps+1);
      else
         printf("\nPress key for final results\n");
     
      if( pauseflag==1 ) getch();

      /*===*/

      if(numcomps<numcomps0) // --- add new component if numcomps0 not reached
      {
         //newcomponent

         /* =====  cdf found by explicit formula or by quadrature ===== */

         /* --- set left support value --- */

         x0 = leftendfind(leftendflag,parpres,sampmean,sampsig);

         leftendvalue = x0;


         /* --- Calc, using parpres -> the goodness of fit stat, also Dval array  --- */

         // comment: not sure why this is done here
         // probably not needed, but not checked.

         fitstat( &adstat, cdfavail, yobsn, n, parpres, Dval);

         /* --- Calc, from Dval -> the maxprobsofar and its posn  (j0,j1)
                                  also maxprobsofar1 and its posn (j2,j3) -- */
         // adjustonflag = pauseflag;


//      printf("just before dvalplot2 pauseflag=%ld\n",pauseflag);
//            printf("j0=%ld j1=%ld j2=%ld j3=%ld\n",j0,j1,j2,j3);

//      getch();

//         if(pauseflag==1)
//         {
//            printf("Dvalplot? (y/n)\n");
//            akey = getch();
//            if(akey=='y') adjustonflag = 1;
//            else adjustonflag = 0;
//         }

         adjustonflag = 0;
         // printf("Dvalplot is off\n");

         Dvalplot2( &adjustonflag, yobsn, n, Dval,
                      &maxprobsofar0, &maxprobsofar1, &j0, &j1, &j2, &j3);



         if(outflag==1) fprintf(fout,"number of components = %ld\n",numcomps);

         // ---- save current best solution as the 'previous' solution for next pass
         for(i=1;i<=numpars;i++) 
         {
            parprev[i]=parpres[i];
         }
      }//newcomponent

   }/* numcomps */

} /*onepass==0*/


 printf("numevals = %d\n",numevals);
 printf("\n==========Final Parameter fit =================\n");
 printf("(Orig) estimates are:\n");
 
 for(j=1;j<numpars;j+=3)
 {
    printf("Component %2ld:  Mean = %lf SD = %lf Weight = %lf\n",
       (j+2)/3, parpres[j], parpres[j+1], parpres[j+2]);
  
 }

 for(i=1;i<=numpars;i++)
 {
    if(outflag==1) fprintf(fout,"parpres[%d] = %lf ", i,  parpres[i]);
    if(i%3==0)
    {
       if(outflag==1) fprintf(fout,"\n");
    }
 }

 for(j=1;j<numpars;j+=3)
 {
    if(parpres[j+1]< samprange/1000.)
    {
       printf("\n");
       printf("WARNING !!!\n");
       printf(" The SD of component %d is small. \n",(j+2)/3);
       printf(" It is %6.4lf percent of the sample range.\n",parpres[j+1]*100/samprange);
       printf(" The coefficient of variation of the component is %lf\n\n",
                 coeffvar);
       printf(" The plots may not be accurate. Consider:\n");
       printf(" 1. Activating spreading of data or, if spreading\n");
       printf("    is already active, increasing Dataspread.\n\n");
       printf(" 2. Alternatively, increase nu_1.\n\n");
       printf(" (It may be necessary to do both.)\n\n");
       printf(" Exit immediately? (This is advisable.) y/n\n");
       akey = getch();
       if(akey=='y') goto ExitLabel;
    }
    if(parpres[j+2]< 1./n )
    {
       printf("\n");
       printf("WARNING !!!\n");
       printf(" The weight of component %d is less than 1/n = %lf\n\n", (j+2)/3, 1./n );
       printf(" Consider increasing delta\n\n");
       printf(" Exit immediately (advisable)? y/n\n");
       akey = getch();
       if(akey=='y') goto ExitLabel;
    }                
 }


 // printf("AIC/BIC = %lf\n",adstat);

 //printf("AIC statistic = %lf\n",aicstat);
 printf("BIC statistic = %lf\n",bicstat);



 if(outflag==1)
 {
    //fprintf(fout,"AIC/BIC statistic = %lf\n",adstat);

    fprintf(fout,"AIC statistic = %lf\n",aicstat);
    fprintf(fout,"BIC statistic = %lf\n",bicstat);
 }


 printf("max prob mode value = %.10lf \n",maxvalue);
 if(outflag==1) fprintf(fout,"max likelihd value = %.10lf \n",maxvalue);

#if GRAPHICSON
 printf(" Graph of max component fit? (y/b/n - default is y)?\n");
 akey = getch();
 if(akey!='n' && akey!='N')
 {
    numcomps = numcomps0;
    x0 = leftendfind(leftendflag,parpres,sampmean,sampsig);
    leftendvalue = x0;
    graphplot(yobsn, n, parpres, 0, Dval, j0, j1, j2, j3);
 }
#endif

/* --------At this point these arrays hold the results of the optimizations
FittedMeanAll [][][]
FittedTauAll  [][][]
FittedDeltaAll[][][]
bestjtryAll       []
maxvalsAll      [][]
infvarsAll  [][][][]
  ---------------- */


ShrinkFactor = 0.5;

for(k=1; k<=numcomps0; k++)
{
   numpars = 3*k;
   //   ------- Get Hessian, shrink it
   for(jtry=0; jtry<=1; jtry++)
   {
      for(i=1; i<=numpars; i++)
      for(j=1; j<=numpars; j++)
      {
         iquotient = (long)((i - 1) / 3);
         iremainder = i - 1 - 3 * iquotient;
         jquotient = (long)((j - 1) / 3);
         jremainder = j - 1 - 3 * jquotient;
      
         it = k * iremainder + iquotient + 1;
         jt = k * jremainder + jquotient + 1;
         Shessian[it][jt] = ShrinkFactor * infvarsAll[i][j][jtry][k];
        
         if (it == jt)
         {
            if(Shessian[it][jt] <= 0)
            {
               // Shrunkhessian(IT, JT) = -x
               Shessian[it][jt] = 0.0000001;
            }
         }     
      }
   
      for(i=1; i<=numpars; i++)
      for(j=1; j<=numpars; j++)
      {
         ShrunkhessiansAll[i][j][jtry][k] = Shessian[i][j];
      }
   }//jtry
} // Next k


// Calculate all Jacobians
for(k=1; k<=numcomps0; k++)
{
   if (k > 1)
   {
      for(i=1; i<=k; i++)
      for(j=1; j<=k; j++)
      {
         if(i == j)
         {
            JacobiansAll[i][j][k] = 1. - 1. / k;
         }
         else
         {
             JacobiansAll[i][j][k] = -1. / k;
         }
      }
   }
   else
   {
      JacobiansAll[1][1][1] = 0;
   }
 
} // Next k


// Calc the modified Hessian matrices
for(k=1; k<=numcomps0; k++)
{
   for(jtry=0;jtry<=1;jtry++)
   {
      // Get Kth shrunkHessian
      for(i=1; i<=3*k; i++)
      for(j=1; j<=3*k; j++)
      {
         Shessian[i][j] = ShrunkhessiansAll[i][j][jtry][k];
      }
      // Get Kth Jacobian
      for(i=1; i<=k; i++)
      for(j=1; j<=k; j++)
      {
         Jacobian[i][j] = JacobiansAll[i][j][k];
      }


      CalculateModifiedHessian(k, Shessian, Jacobian, ModHessian);
      // Calculate and save Modified Hessian
      for(i=1; i<=3*k; i++)
      for(j=1; j<=3*k; j++)
      {
         ModHessiansAll[i][j][jtry][k] = ModHessian[i][j];
      }
   }//jtry
}

// ---- Calculate the generalised inverse using the routine found in matrixInversion module
NegEigenvalueCount = 0;
for(jtry=0;jtry<=1;jtry++)
{
   for(k=1; k<=numcomps0; k++)
   {   
      for(i=1; i<=3*k; i++)
      for(j=1; j<=3*k; j++)
      {
         invCov[i][j] = ModHessiansAll[i][j][jtry][k];
      }
      //  ==== This routine returns sampleL []
      // === this is the L of my original 'Symmetric way' notes, but without the last column of zeroes

      CalcGeneralisedInverse( invCov, sampleL, k, &NegEigenvalueCount);
      /*----
      for(i=1; i<=3*k; i++)
      for(j=1; j<=3*k-1; j++)
      {
         sampleLsAll[i][j][jtry][k] = sampleL[i][j];
      }
      ----*/

#if 1      
      if(k==1) // calculate and save SD's of first two params
      {
/* =================
        for(i=1;i<=2;i++)
        {
           for(j=1;j<=2;j++)
           {
             printf("sampleL[%2ld][%2ld]=%lf ", i, j, sampleL[i][j] );
           }
           printf("\n");
        }
        getch();
================== */
        sd1 = 0.0;
        sd2 = 0.0;
        for(j=1; j<=2; j++)
        {
           sd1 += pow(sampleL[1][j], 2.0);
           sd2 += pow(sampleL[2][j], 2.0);
           sampleLsAll[1][j][jtry][k] = sampleL[1][j];
           sampleLsAll[2][j][jtry][k] = sampleL[2][j];
           sampleLsAll[3][j][jtry][k] = sampleL[3][j];
        }
        sd1 = SDEXPAND * sqrt(sd1); // SD of cand distn of 1st param.
        sd2 = SDEXPAND * sqrt(sd2); // SD of cand distn of 2nd param.
      }
      if(k>1)
      {
         for(i=1; i<=k; i++) /* the mu params */
         {
#if 1
            sd0 = 0.0;
            for(j=1; j<=3*k-1; j++)
            {
               sd0 += pow(sampleL[i][j], 2.0);
            }
            sd0 = sqrt( sd0 );
            // printf("i=%ld k=%ld at mu sd0 = %lf sd1 = %lf\n",i,k, sd0,sd1);
            if(sd0 > sd1)
            {
               sd0 = sd1/sd0; // This caps the variation of the candidate mus
            }
            else
            {
               sd0 = 1.0;
            }
            for(j=1; j<=3*k-1; j++)
            {
               sampleLsAll[i][j][jtry][k] = sd0*sampleL[i][j];
            }
#endif
//            for(j=1; j<=3*k-1; j++)
//            {
//               sampleLsAll[i][j][jtry][k] = sampleL[i][j];
//            }
         }
         for(i=k+1; i<=2*k; i++) /* the tau params */
         {
#if 1
            sd0 = 0.0;
            for(j=1; j<=3*k-1; j++)
            {
               sd0 += pow(sampleL[i][j], 2.0);
            }
            sd0 = sqrt( sd0 );
// printf("i=%ld k=%ld at tau sd0 = %lf sd2 = %lf\n",i,k, sd0,sd2);
// getch();
            if(sd0 > sd2)
            {
               sd0 = sd2/sd0; // This caps the variation of the candidate taus
            }
            else
            {
               sd0 = 1.0;
            }
            for(j=1; j<=3*k-1; j++)
            {
               sampleLsAll[i][j][jtry][k] = sd0*sampleL[i][j];
            }
#endif
//            for(j=1; j<=3*k-1; j++)
//            {
//               sampleLsAll[i][j][jtry][k] = sampleL[i][j];
//            }
         }

      }/*k>1*/

      for(i=2*k+1; i<=3*k; i++) /* the weights part */
      {
#if 1
         sd3 = 0.0;
         for(j=1; j<=3*k-1; j++)
         {
            sd3 += pow(sampleL[i][j], 2.0);;
         }
         sd3 = sqrt( sd3 );
         if(sd3 > SDCAP) // This caps the variation allowed in the sampling of wts
         {
            for(j=1; j<=3*k-1; j++)
            {
               sampleLsAll[i][j][jtry][k] = SDCAP * sampleL[i][j]/sd3;
            }
         }
         else // no need to rescale if sd0 is small anyway
         {
            for(j=1; j<=3*k-1; j++)
            {
               sampleLsAll[i][j][jtry][k] = sampleL[i][j];
            }
         }
#endif
//         for(j=1; j<=3*k-1; j++)
//         {
//            sampleLsAll[i][j][jtry][k] = sampleL[i][j];
//         }

      }/* i - wts */
#endif

   }/*k*/
}/*jtry*/

if(NegEigenvalueCount == 0)
{
   printf("\n");
   printf("None of the eigenvalues in any of the fits are negative.\n\n");
   printf("This is indicative of reasonable fits for all k values.\n\n");
   printf("However it is best to check that none of the fits contain\n");
   printf("unusually narrow components.\n\n");
}
else
{
   if(NegEigenvalueCount ==1)
   {
      printf("\n");
      printf("There is a negative eigenvalue.\n\n");
   }
   if(NegEigenvalueCount > 1)
   {
      printf("\n");
      printf("There are %ld negative eigenvalues.\n\n", NegEigenvalueCount);
   }
   printf("This is an indication of some poor fits,\n");
   printf("usually arising through spikey delta components.\n\n");
   printf("Increase the values of the delta and nu1 parameters to eliminate these.\n\n");
}

// ===== Check for replicated components =====
for(numcomps=1; numcomps<=numcomps0; numcomps++)
{
   for(j=1; j<numcomps; j++)
   {
      k = 0;
      for(jtry=0; jtry<=1; jtry++)
      {
         m1 = FittedMeanAll [j][jtry][numcomps];
         m2 = FittedMeanAll [j+1][jtry][numcomps];
         t1 = FittedTauAll  [j][jtry][numcomps];
         t2 = FittedTauAll  [j+1][jtry][numcomps];
         if(m1!=0.0 && m2!=0.0)
         {
            diff = fabs( (m1-m2)/sqrt( m1*m1+m2*m2 ) );
         }
         else
         {
            diff = 0.0;  
         }
         if(t1!=0.0 && t2!=0.0)
         {
            diff = diff + fabs( (t1-t2)/sqrt( t1*t1+t2*t2 ) );
         }
         else
         {
            diff = diff + 0.0; // reminder
         }
         if(diff <= 0.001) // arbitrary choice of small
         {
             if(jtry==0)
             {
                printf("Warning: At k=%ld, jtry=%ld: components %ld and %ld very similar:\n",
                        numcomps, jtry, j, j+1);
             }
             else
             {
                printf("Minor warning: At secondary fit k=%ld, jtry=%ld: components %ld and %ld very similar:\n",
                        numcomps, jtry, j, j+1);
             }

             printf("mu[%ld]=%lf, mu[%ld]=%lf\n", j, m1, j+1, m2);
             printf("sd[%ld]=%lf, sd[%ld]=%lf\n", j, t1, j+1, t2);
             k++;
         }
      }/*jtry*/
      if(k > 0)
      {
         printf("\nIf there are no spikes, this may be due to delta or nu1 being too large.\n\n");
         getch();
      }
   }
}

/* === The next 2 sections are for diagnostics only and are not usually used === */
#if 0
// Find generalised inverses of modified Hessians
fp7 = fopen("out7.d","w");
NegEigenvalueCount = 0;
for(k=1; k<=numcomps0; k++)
{
   jtry=bestjtryAll[k];
   
   for(i=1; i<=3*k; i++)
   for(j=1; j<=3*k; j++)
   {
      invCov[i][j] = ModHessiansAll[i][j][jtry][k];
   }
   //  this routine returns sampleL []
   CalcGeneralisedInverse( invCov, sampleL, k, &NegEigenvalueCount);
}
fclose(fp7);

// ==== not usually used =====

fp5 = fopen("out5.d","w");

for(k=1; k<=numcomps0; k++)
{
      fprintf(fp5," ShrunkHess %ld\n", k);
      numpars = 3*k;
      bestjtry = bestjtryAll[k];
      for(i=1; i<=numpars; i++)
      for(j=1; j<=numpars; j++)
      {
         fprintf(fp5, " %lf", ShrunkhessiansAll[i][j][bestjtry][k]);
         if(j%numpars==0) fprintf(fp5,"\n");
      }
} // Next k

for(k=1; k<=numcomps0; k++)
{
      fprintf(fp5," ModHess %ld\n",k);
      numpars = 3*k;
      bestjtry = bestjtryAll[k];
      for(i=1; i<=numpars; i++)
      for(j=1; j<=numpars; j++)
      {
         fprintf(fp5, " %lf", ModHessiansAll[i][j][bestjtry][k]);
         if(j%numpars==0) fprintf(fp5,"\n");         
      }
}
fclose(fp5);

/* ==== above section is for diagnostics only and is not usually used ==== */
#endif


// ======== Out9.d is the main results file of the fitter program tmain.exe
// ======== this file is the input data file for imp.exe =========
// ======== it is also read by the Excel file to get the results 

fp9 = fopen(DataFolderOut9,"w");

fprintf(fp9,"%ld\n",n);

for(i=1;i<=n;i++)
{
   fprintf(fp9,"%e\n",yobsn[i]);
}

// sampleBeta = 0.0;

fprintf(fp9,"%ld\n", model);
fprintf(fp9,"%ld\n", numoISsamples);

fprintf(fp9,"%le\n", minSD );

// fprintf(fp9,"%le\n", tauConst);

for(i=1;i<=17;i++)
{
   fprintf(fp9,"%le\n",priorpar[i]);
}

for(k=1; k<=numcomps0; k++)
{
   for(jtry=0; jtry<TWO; jtry++)
   {
      for(j=1; j<=k; j++)
      {
         fprintf(fp9,"%le ", FittedMeanAll  [j] [jtry] [k] );
         fprintf(fp9,"%le ", FittedTauAll   [j] [jtry] [k] );
         fprintf(fp9,"%le\n", FittedDeltaAll [j] [jtry] [k] );
      }

      fprintf(fp9,"%le ",  AICStatAll  [jtry] [k] );
      fprintf(fp9,"%le\n", BICStatAll  [jtry] [k] );

   }
}

for(k=1; k<=numcomps0; k++)
{
   fprintf(fp9,"%ld\n", bestjtryAll [k] );
}

for(k=1; k<=numcomps0; k++)
{
   for(jtry=0; jtry<TWO; jtry++)
   {
      fprintf(fp9,"%le\n", maxvalsAll [jtry] [k] );
   }
}

for(k=1; k<=numcomps0; k++)
{
   numpars = 3*k;
   for(i=1;i<=numpars;i++)
   {
      for(j=1;j<=numpars;j++)
      {
         for(jtry=0; jtry<TWO; jtry++)
         {
            fprintf(fp9,"%le ", infvarsAll [i][j][jtry][k] ); 
            fprintf(fp9,"%le\n", sampleLsAll[i][j][jtry][k] ); 
         }
      }
   }
}

fclose(fp9);

//  This completes the covariance calculations ===============


#endif // 

printf("Out9.d file produced\n");
printf("Press key to finish\n");
getch();


ExitLabel:
;

}/*0*/
/* =========== end of main ========== */


